VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPlugin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Implements core.IBasePlugin
Private m_oForm As console.frmMain
Private m_sName As String
Private Sub IBasePlugin_StartPlugin(Name As String)
    
    Set oServer = CreateObject("core.CServer")
    oServer.RegisterBang Name, "!log"
    oServer.RegisterBang Name, "!hide"
    oServer.RegisterBang Name, "!show"
    oServer.RegisterBang Name, "!toggle"
    m_sName = Name
    Set m_oForm = New console.frmMain
    Call Load(m_oForm)
    
    m_oForm.Left = oServer.evalNum(oServer.GetKey(m_sName, "x")) * Screen.TwipsPerPixelX
    m_oForm.Top = oServer.evalNum(oServer.GetKey(m_sName, "y")) * Screen.TwipsPerPixelY
    m_oForm.Width = oServer.evalNum(oServer.GetKey(m_sName, "width")) * Screen.TwipsPerPixelX
    m_oForm.Height = oServer.evalNum(oServer.GetKey(m_sName, "height")) * Screen.TwipsPerPixelY
    m_oForm.Picture = LoadPicture(oServer.GetKey("core", "background"))
    m_oForm.txtCommand.BackColor = CLng("&H" & oServer.GetKey("core", "bgcolor"))
    m_oForm.txtCommand.ForeColor = CLng("&H" & oServer.GetKey("core", "fgcolor"))
    m_oForm.txtCommand.Font = oServer.GetKey("core", "textfont")
    m_oForm.txtCommand.FontSize = oServer.GetKey("core", "textsize")
    m_oForm.lstConsole.BackColor = m_oForm.txtCommand.BackColor
    m_oForm.lstConsole.ForeColor = m_oForm.txtCommand.ForeColor
    m_oForm.lstConsole.Font = m_oForm.txtCommand.Font
    m_oForm.lstConsole.FontSize = m_oForm.txtCommand.FontSize
    m_oForm.lstConsole.Width = m_oForm.ScaleWidth
    m_oForm.lstConsole.Height = m_oForm.ScaleHeight - m_oForm.txtCommand.Height
    m_oForm.txtCommand.Width = m_oForm.ScaleWidth
    m_oForm.txtCommand.Top = m_oForm.lstConsole.Height
    oServer.skin m_oForm
    m_oForm.lblBar.Top = oServer.evalNum(oServer.GetKey("core", "bartop"))
    m_oForm.lblBar.Left = oServer.evalNum(oServer.GetKey("core", "barleft"))
    If oServer.evalNum(oServer.GetKey("core", "barwidth")) < 0 Then
        m_oForm.lblBar.Width = m_oForm.ScaleWidth + oServer.evalNum(oServer.GetKey("core", "barwidth")) - m_oForm.lblBar.Left
    Else
        m_oForm.lblBar.Width = oServer.evalNum(oServer.GetKey("core", "barwidth"))
    End If
    If oServer.evalNum(oServer.GetKey("core", "barheight")) < 0 Then
        m_oForm.lblBar.Height = m_oForm.ScaleHeight + oServer.evalNum(oServer.GetKey("core", "barheight")) - m_oForm.lblBar.Top
    Else
        m_oForm.lblBar.Height = oServer.evalNum(oServer.GetKey("core", "barheight"))
    End If
    m_oForm.Tag = Name
    Call m_oForm.Show

End Sub
Private Sub IBasePlugin_StopPlugin()
    
    If oServer.evalNum(oServer.GetKey(m_sName, "x")) * Screen.TwipsPerPixelX <> m_oForm.Left Then
        oServer.SetKey m_sName, "x", m_oForm.Left / Screen.TwipsPerPixelX
    End If
    If oServer.evalNum(oServer.GetKey(m_sName, "y")) * Screen.TwipsPerPixelY <> m_oForm.Top Then
        oServer.SetKey m_sName, "y", m_oForm.Top / Screen.TwipsPerPixelY
    End If
    Call m_oForm.Hide
    Call Unload(m_oForm)
    Set m_oForm = Nothing

End Sub
Private Sub IBasePlugin_Bang(Name As String, Arguments As String)

    Select Case Name
    Case "!log"
        If oServer.evalBool(oServer.GetKey(m_sName, "showwhen")) Then
            m_oForm.lstConsole.AddItem Now & " : " & Arguments
        Else
            m_oForm.lstConsole.AddItem Arguments
        End If
        m_oForm.lstConsole.ListIndex = frmMain.lstConsole.ListCount - 1
    Case "!hide"
        If LCase(Arguments) = LCase(m_sName) Then
            m_oForm.Visible = False
        End If
    Case "!show"
        If LCase(Arguments) = LCase(m_sName) Then
            m_oForm.Visible = True
        End If
    Case "!toggle"
        If LCase(Arguments) = LCase(m_sName) Then
            m_oForm.Visible = Not m_oForm.Visible
        End If
    End Select
   
End Sub
Public Property Get IBasePlugin_Name() As String

    IBasePlugin_Name = m_sName

End Property
